MODULE Assertion EXPORTS Assertion;
(*
Dieses Modul bietet zwei funktionen die zur formulierung von vor- und nachbedingung.

Autor : Horst Lichter, RWTH Aachen
Umgebung : SRC-Modula-3 rel. 3.6, Windows NT 4.0
Erstellt : 16.08.98
Letzte Aenderung: 11.01.2001
*)

IMPORT SIO;

VAR enabled : BOOLEAN;

PROCEDURE Require (expr : BOOLEAN; procName: TEXT) RAISES {Violated} =
(* Vorbedingung, ist expr nicht TRUE wird eine Fehlermeldung ausgegeben und durch RAISE 
   eine EXCEPTION an die rufende Procedure zurckgegeben *)
BEGIN
  IF enabled AND NOT expr THEN
    SIO.PutLine("*** Precondition violated: " & procName);
    RAISE Violated;
  END;
END Require;

PROCEDURE Ensure  (expr : BOOLEAN; procName: TEXT) RAISES {Violated} =
(* Nachbedingung, ist expr nicht TRUE wird eine Fehlermeldung ausgegeben und durch RAISE 
   eine EXCEPTION an die rufende Procedure zurckgegeben *)
BEGIN
  IF enabled AND NOT expr THEN
    SIO.PutLine("*** Postcondition violated: " & procName);
    RAISE Violated;
  END;
END Ensure;


(* Die beiden folgenden Proceduren ermglichen das ein und ausschalten der zusicherungen *)
PROCEDURE EnableAssertions()=
BEGIN
  enabled := TRUE;
END EnableAssertions;

PROCEDURE DisableAssertions()=
BEGIN
  enabled := FALSE;
END DisableAssertions;


BEGIN
  EnableAssertions(); (* Bei der Initialisierung des Moduls werden die Zusicherungen eingeschaltet *)
END Assertion.